      SUBROUTINE    TEMPD(TOLD, TNEW, TDIF, NOUT, LPR)
      INTEGER       NOUT
      REAL*8        TOLD, TNEW, TDIF
      LOGICAL       LPR
C
C     SGI PCL TIMING ROUTINE, USING DTIME.
C     DTIME REPORTS ELAPSED EXECUTION TIME (USER, SYSTEM) SINCE THE
C     LAST CALL TO ITSELF; THEREFORE THIS PROGRAM WORKS OK ONLY IF THERE
C     ARE NO OTHER CALLS TO DTIME EXCEPT FROM THIS PROGRAM.
C     (DTIME MAY NOT MEASURE THE CPU TIME ITSELF.)
C
C     INPUT:  TOLD, NOUT, LPR (ALL UNCHANGED).
C     OUTPUT: TNEW (CUMULATIVE TIME), TDIF (DIFFERENCE FROM TOLD).
C     TCUM SAVES THE CUMULATIVE TIME.
C
      LOGICAL   INIT, TEST
      REAL*4    DTIME, TARRAY 
      DIMENSION TARRAY(2)
      REAL*8    TSUM, TCUM, SCUM, SDIF
      DATA      INIT / .TRUE. /, TEST / .FALSE. /
      DATA      TCUM / 0.D0 /, SCUM / 0.D0 /
C
      IF (INIT) THEN
          WRITE (NOUT,2000)
          INIT = .FALSE.
C
          TSUM = DTIME(TARRAY)
          TCUM = TCUM + TARRAY(1)
          SCUM = SCUM + TARRAY(2)
C
          TNEW = TCUM
          TDIF = TNEW - TOLD
          IF (TEST) WRITE (NOUT,2200) TSUM, TNEW, TDIF, TOLD, SCUM, SDIF
          RETURN
      ENDIF
C
      TSUM = DTIME(TARRAY)
      TCUM = TCUM + TARRAY(1)
      SCUM = SCUM + TARRAY(2)
C
      TNEW = TCUM
      TDIF = TNEW - TOLD
      IF (TEST) WRITE (NOUT,2200) TSUM, TNEW, TDIF, TOLD, SCUM, SDIF
      IF (LPR) WRITE (NOUT,2100) TNEW, TDIF, TOLD, SCUM
      RETURN
C
 2000 FORMAT (' -TEMPD- 4.0, 96/01/19. SGI PC TIMING ROUTINE.') 
 2100 FORMAT ('   USER', F12.2,
     A                  '     DIF', F12.2,
     B                  '     REF', F12.2,
     C                  '     SYS', F12.2)
 2200 FORMAT (' SUM USER DIF OLD SYS SDIF', 6F8.2)
      END
